#!/bin/bash
SCRIPT_ABS_LOCATION=$(realpath "$(dirname "${0}")")

# shellcheck disable=SC1090
source "$SCRIPT_ABS_LOCATION/../common-backup.sh"
# shellcheck disable=SC1090
source "$SCRIPT_ABS_LOCATION/immich-backup.env"

# shellcheck disable=SC2034
LOG_FILE="$SCRIPT_ABS_LOCATION/immich-backup.log"

dump_postgres_db "$DB_CONTAINER" "$DB_USER" "/var/lib/postgresql/data/$DB_TMP_BAK_NAME"

run_duplicati_backup \
  "$BACKUP_DESTINATION" \
  "$APP_CONTAINER" \
  7 \
  "$SFTP_USERNAME" \
  "$SFTP_PASSWORD" \
  "$SFTP_FINGERPRINT" \
  "$BACKUP_ENCR_PASSPHRASE" \
  "$SOURCE_DIR/data/library" \
  "$SOURCE_DIR/data/upload" \
  "$SOURCE_DIR/data/profile" \
  "$SOURCE_DIR/postgres/$DB_TMP_BAK_NAME"

log "Deleting immich temp DB backup..."
docker exec "$DB_CONTAINER" rm "/var/lib/postgresql/data/$DB_TMP_BAK_NAME" || {
  log "Error: Failed to delete temp DB backup."
  exit 1
}

