#!/bin/bash
SCRIPT_ABS_LOCATION=$(realpath "$(dirname "${0}")")

# shellcheck disable=SC1090
source "$SCRIPT_ABS_LOCATION/../common-backup.sh"
# shellcheck disable=SC1090
source "$SCRIPT_ABS_LOCATION/vaultwarden-backup.env"

# shellcheck disable=SC2034
LOG_FILE="$SCRIPT_ABS_LOCATION/vaultwarden-backup.log"

dump_sqlite_db "$SOURCE_DIR/db.sqlite3" "$SOURCE_DIR/$DB_TMP_BAK_NAME"

run_duplicati_backup \
  "$BACKUP_DESTINATION" \
  "vaultwarden" \
  7 \
  "$SFTP_USERNAME" \
  "$SFTP_PASSWORD" \
  "$SFTP_FINGERPRINT" \
  "$BACKUP_ENCR_PASSPHRASE" \
  "$SOURCE_DIR"

log "Deleting vaultwarden temp DB backup..."
rm "$SOURCE_DIR/$DB_TMP_BAK_NAME" || {
  log "Error: Failed to delete temp DB backup."
  exit 1
}

